<?php
	if(!function_exists('pre')){
	function pre($data){
			if(isset($_GET['debug'])){
				pree($data);
			}
		}	 
	} 	
	if(!function_exists('pree')){
	function pree($data){
				echo '<pre>';
				print_r($data);
				echo '</pre>';	
		
		}	 
	} 
	add_action( 'admin_enqueue_scripts', 'register_wpshopify_scripts' );
	add_action( 'wp_enqueue_scripts', 'register_wpshopify_scripts' );
	function register_wpshopify_scripts(){
		
		if(array_key_exists('page', $_GET) && $_GET['page']=='wp_shopify'){
			
			wp_enqueue_script(
				'wp-shopify-scripts',
				plugins_url('js/scripts.js', dirname(__FILE__)),
				array('jquery')
			);	
			
			
			
			
				
			if(is_admin()){			
				wp_enqueue_style('wp-shopify-styles', plugins_url('css/admin-styles.css', dirname(__FILE__)), array(), date('Ymdh'), 'all' );
				
				wp_enqueue_script(
					'fontawesome',
					plugins_url('js/fontawesome.min.js', dirname(__FILE__)),
					array('jquery')
				);	
				
				wp_enqueue_style('fontawesome', plugins_url('css/fontawesome.min.css', dirname(__FILE__)), array(), date('Ymd'), 'all' );

				wp_enqueue_script(
					'bootstrap',
					plugins_url('js/bootstrap.min.js', dirname(__FILE__)),
					array('jquery')
				);	
				
				wp_enqueue_style('bootstrap', plugins_url('css/bootstrap.min.css', dirname(__FILE__)), array(), date('Ymd'), 'all' );
				
			}else{
				wp_enqueue_style('wp-shopify-styles', plugins_url('css/front-styles.css', dirname(__FILE__)), array(), date('Ymd'), 'all' );
			}
			
		}
			
	}	
	
	function wpsy_product_price($product_data){
		
		$variants = $product_data->variants;
		$prices = array();
		if(!empty($variants)){
		   foreach($variants as $variant){
			   $prices[] = $variant->price;
		   }
		}
		return (min($prices)!=max($prices)?wpsy_shop_product_display_price(sanitize_text_field(min($prices))).' - '.wpsy_shop_product_display_price(sanitize_text_field(max($prices))):wpsy_shop_product_display_price(sanitize_text_field(min($prices))));		
	}
		
	function wpsy_shop_display_shortcode($atts = array(), $content = null, $tag = ''){
		
		$atts = array_change_key_case((array)$atts, CASE_LOWER);
		$wpsy_db_data = get_option('wpsy_db_data');
		$url = $wpsy_db_data['wpsy_url'];
		$api_key = $wpsy_db_data['wpsy_api_key'];
		$password = $wpsy_db_data['wpsy_password'];
		$collection_id = (isset($atts['collection_id'])?'?collection_id='.$atts['collection_id']:'');
		$wpsy_limit = (isset($atts['limit'])?$atts['limit']:'');
	
	   //API URL to get product by ID
		$requestURL = "https://" . $api_key . ":" . $password . "@" . $url;
		$requestURL .= '/admin/products.json'.$collection_id;
		$response = wp_remote_get($requestURL, array(
		  'headers' => array('Content-Type' => 'application/json; charset=utf-8'),
		  'body' => null,
	   ));
	   //pree($response);
	   if (is_wp_error($response)) {
		  $o = wpsy_shop_product_display_get_error(__('Product query failure','wp-shopify').':'  . $response->get_error_message());
		  return $o;
	   }  else if (wp_remote_retrieve_response_code( $response ) != 200) {
		  $o = wpsy_shop_product_display_get_error(__('Product query unexpected return','wp-shopify').':'  . wp_remote_retrieve_response_message( $response )); 
		  return $o;
	   }
	   $response = json_decode(wp_remote_retrieve_body($response));	
	   ob_start();
	   if(!empty($response) && isset($response->products)){
		   
		   
	?>
	<ul class="wp_shopify">
	<?php	   
			$wpsy_count = 0;
			foreach($response->products as $product_data){
				
				$wpsy_count++;
				
				if (is_numeric($wpsy_limit) && $wpsy_limit>0 && $wpsy_count >= $wpsy_limit){
					continue;	
				}
			   
				$product_data->price = wpsy_product_price($product_data);
				$product_url = home_url().'/product/?id='.$product_data->id;
	?>
	<li>
	<a title="<?php echo ucwords($product_data->product_type); ?>" href="<?php echo $product_url; ?>"><img alt="<?php echo $product_data->title; ?>" src="<?php echo $product_data->image->src; ?>" /></a>
	<a class="ptitle" href="<?php echo $product_url; ?>"><?php echo $product_data->title; ?></a>
	<strong><?php echo $product_data->price; ?></strong>
	</li>
	<?php		   
		   }
	?>
	</ul>
	<?php	   


		$o = ob_get_contents();
		
		ob_end_clean();
		   
	   }
	   
	   return $o;
	}
	
	function wpsy_shop_product_display_shortcode($atts = array(), $content = null, $tag = '')
	{
		// normalize attribute keys, lowercase
		$atts = array_change_key_case((array)$atts, CASE_LOWER);
		$id = ($atts['id']?$atts['id']:$_GET['id']);
		
		$wpsy_db_data = get_option('wpsy_db_data');
		$url = $wpsy_db_data['wpsy_url'];
		$api_key = $wpsy_db_data['wpsy_api_key'];
		$password = $wpsy_db_data['wpsy_password'];
		
		//API URL to get product by ID
		$requestURL = "https://" . $api_key . ":" . $password . "@" . $url;
		$requestURL .= "/admin/products/" . $id . ".json";
		//echo $requestURL;exit;
		$response = wp_remote_get($requestURL, array(
		  'headers' => array('Content-Type' => 'application/json; charset=utf-8'),
		  'body' => null,
		));
		if (is_wp_error($response)) {
		  $o = wpsy_shop_product_display_get_error(__('Product query failure','wp-shopify').':'  . $response->get_error_message());
		  return $o;
		}  else if (wp_remote_retrieve_response_code( $response ) != 200) {
		  $o = wpsy_shop_product_display_get_error(__('Product query unexpected return','wp-shopify').':'  . wp_remote_retrieve_response_message( $response )); 
		  return $o;
		}
		$response = json_decode(wp_remote_retrieve_body($response));
		//pree($response);
		
		$images = $response->product->images;
	
		$data['name'] = ' ';
		$data['price'] = ' ';
		$data['special'] = ' ';
		$data['link'] = ' ';
		$data['image'] = ' ';
		$data['description'] = ' ';
		
		// Fill from response
		$data['name'] = sanitize_text_field($response->product->title);
		
		// show lowest price
		foreach($response->product->variants as $variant) { 
		  if (!isset($price)) {
			 $price = $variant->price; 
		  } else {
			 if ($variant->price < $price) $price = $variant->price; 
		  }
		}
		$data['price'] = wpsy_product_price($response->product);
		// field contains HTML markup
		$data['description'] = wp_kses_post($response->product->body_html);
		$image_url = esc_url($response->product->image->src); 
		$data['image'] = '<img data-src="'.$image_url.'" src="' . sanitize_text_field($image_url) . '" />';
		$data['link'] = "https://" . $url . "/products/" . sanitize_text_field($response->product->handle);
		
		// start output
		$o = '';
		
		// start box
		$o .= '<div class="wp_shopify_product">';
		
		$o .= '<div class="prod-left">' . '<a href="' . $data['link'] . '">' . $data['image'] . '</a>' . '';

		if(!empty($images)){
			$o .= '<div class="prod-gallery">' . '<ul>';
			foreach($images as $img){
				if($img->src!=$image_url){
					$o .= '<li><a href="' . $img->src . '"><img src="'.$img->src.'" /></a>' . '</li>';
				}
			}
			$o .= '</ul></div>';
		}
		
		$o .= '</div>';
		
		$o .= '<div class="prod-upper">';
		$o .= '<div class="prod-right">' . '<a target="_blank" href="' . $data['link'] . '"><h3>' . $data['name'] . '</h3></a>' . '<br />';
		$o .= '<div class="prod-price">' .$data['price']. '</div>';
		$o .= '<div class="prod-buy"><a href="' . $data['link'] . '" target="_blank"><img src="'.plugins_url( 'images/btn.png', dirname(__FILE__) ).'" /></a></div>';
		$o .= '</div>';//prod-right
		$o .= '</div>';//prod-upper
		$o .= '<div class="prod-clear"></div>';
		$o .= '<div class="prod-desc">' . $data['description'] . '</div>';
		
		// enclosing tags
		if (!is_null($content)) {
		  // secure output by executing the_content filter hook on $content
		  $o .= apply_filters('the_content', $content);
		
		  // run shortcode parser recursively
		  $o .= do_shortcode($content);
		}
		
		// end box
		$o .= '</div>';
		
		// return output
		return $o;
	}
	
	function wpsy_shop_product_display_price($price)
	{
	   setlocale(LC_MONETARY, 'en_US');
	   return money_format('%.2n', $price);
	}
	
	function wpsy_shop_product_display_get_error($msg)
	{
	
	   $o = '<div class="shop_product_display-box">';
	   $o .= $msg;
	   $o .= '</div>';
	   return $o;
	}
	
	function wpsy_shop_product_display_shortcodes_init()
	{
	   wp_register_style('shop_product_display', plugins_url('css/front-styles.css', dirname(__FILE__)));
	   wp_enqueue_style('shop_product_display');
	
	   add_shortcode('wp-shopify', 'wpsy_shop_display_shortcode');
	   add_shortcode('wp-shopify-product', 'wpsy_shop_product_display_shortcode');
	
	}
	
	add_action('init', 'wpsy_shop_product_display_shortcodes_init');
	
	add_action('admin_menu', 'wpsy_add_admin_menu');
	add_action('admin_init', 'wpsy_settings_init');
	
	
	function wpsy_add_admin_menu()
	{
		global $wpsy_data;
		add_options_page($wpsy_data['Name'], $wpsy_data['Name'], 'manage_options', 'wp_shopify', 'wp_shopify_settings');
	
	}

	
	function shoppd_settings_section_callback()
	{
	
	   echo __('Please fill the required fields.','wp-shopify');
	
	}	
	
	function wpsy_settings_init()
	{
	
	   register_setting('wpsy_settings_page', 'wpsy_db_data');
	   
	   
	   add_settings_section(
		  'wpsy_settings_page_section',
		  '&nbsp;',
		  'shoppd_settings_section_callback',
		  'wpsy_settings_page'
	   );	

	   $args = array('size' => '80');
	   add_settings_field(
		  'wpsy_url',
		  __('Shopify Domain (no http://)','wp-shopify'),
		  'wpsy_url_render',
		  'wpsy_settings_page',
		  'wpsy_settings_page_section',
		  $args
	   );
	   add_settings_field(
		  'wpsy_api_key',
		  __('Shopify Private app API key','wp-shopify'),
		  'wpsy_api_key_render',
		  'wpsy_settings_page',
		  'wpsy_settings_page_section',
		  $args
	   );
	   add_settings_field(
		  'wpsy_password',
		  __('Shopify Private app Password', 'wordpress'),
		  'wpsy_password_render',
		  'wpsy_settings_page',
		  'wpsy_settings_page_section',
		  $args
	   );
	
	
	}
	
	
	function wpsy_url_render($args)
	{
	
	   $options = get_option('wpsy_db_data');
	   ?>
		<input type='text' name='wpsy_db_data[wpsy_url]' value='<?php echo $options['wpsy_url']; ?>'
		   <?php
		   if (is_array($args) && sizeof($args) > 0) {
			  foreach ($args as $key => $value) {
				 echo $key . "=" . $value . " ";
			  }
		   }
		   ?>>
	   <?php
	
	}
	
	function wpsy_api_key_render($args)
	{
	
	   $options = get_option('wpsy_db_data');
	   ?>
		<input type='text' name='wpsy_db_data[wpsy_api_key]' value='<?php echo $options['wpsy_api_key']; ?>'
		   <?php
		   if (is_array($args) && sizeof($args) > 0) {
			  foreach ($args as $key => $value) {
				 echo $key . "=" . $value . " ";
			  }
		   }
		   ?>>
	   <?php
	
	}
	
	function wpsy_password_render($args)
	{
	
	   $options = get_option('wpsy_db_data');
	   ?>
		<input type='text' name='wpsy_db_data[wpsy_password]' value='<?php echo $options['wpsy_password']; ?>'
		   <?php
		   if (is_array($args) && sizeof($args) > 0) {
			  foreach ($args as $key => $value) {
				 echo $key . "=" . $value . " ";
			  }
		   }
		   ?>>
	   <?php
	
	}
	
	
	function wp_shopify_settings()
	{
		include('wps_settings.php');

	
	}
	
	
	function wp_shopify_admin_links($links) { 

		global $wpsy_premium_copy, $wpsy_pro;


		$settings_link = '<a href="admin.php?page=wp_shopify">'.__('Settings', 'wp-shopify').'</a>';

		
		if($wpsy_pro){
			array_unshift($links, $settings_link); 
		}else{
			 
			$wpsy_premium_link = '<a href="'.esc_url($wpsy_premium_copy).'" title="'.__('Go Premium', 'wp-shopify').'" target="_blank">'.__('Go Premium', 'wp-shopify').'</a>'; 
			array_unshift($links, $settings_link, $wpsy_premium_link); 
		
		}
				
		
		return $links; 
	}