<?php if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

	global $wpsy_data, $wpsy_pro, $wpsy_premium_copy;

	
?>

<div class="wrap wpsy_settings_div">

        

<h2><?php echo $wpsy_data['Name']; ?> <?php echo '('.$wpsy_data['Version'].($wpsy_pro?') Pro':')'); ?> - <?php _e('Settings','wp-shopify'); ?> </h2> 


    <h2 class="nav-tab-wrapper">

        <a class="nav-tab nav-tab-active" data-tab="config-settings"><?php _e("Configuration",'wp-shopify'); ?> <i class="fas fa-tools"></i></a>
        
        <a class="nav-tab" data-tab="shortcodes"><?php _e("Shortcodes",'wp-shopify'); ?> <i class="fas fa-code"></i></a>

        <a class="nav-tab" style="float:right" data-tab="help"><?php _e("Help",'wp-shopify'); ?> <i class="fas fa-question-circle"></i></a>

    </h2>
    
    <div class="nav-tab-content container-fluid tab-config-settings" data-content="config-settings">
            
    <form action="options.php" method="post" class="ignore">
        
    <?php
			settings_fields('wpsy_settings_page');
			do_settings_sections('wpsy_settings_page');
			submit_button();
    ?>
        
    </form>
    
    
    

            
    </div>      
    
   	 <div class="nav-tab-content container-fluid hides tab-shortcodes" data-content="shortcodes">
    
        <div class="row mt-3">
         

            <ol>
            <li>[wp-shopify]</li>
            <li>[wp-shopify-product]
            <br /><br />
			<small><?php echo __('OR'); ?> [wp-shopify-product id="<?php echo __('some product ID'); ?>"]</small>
            <br /><br /></li>
            <li>[wp-shopify collection_id="141421936749" limit="4"]</li>
            </ol>

		</div>    
	
    </div>        
    
    <div class="nav-tab-content container-fluid hides tab-help" data-content="help">
    
        <div class="row mt-3">
        
            <ul class="position-relative">
                <li><a class="btn btn-sm btn-info" href="https://wordpress.org/support/plugin/wp-shopify/" target="_blank"><?php _e('Open a Ticket on Support Forums', 'wp-shopify'); ?> &nbsp;<i class="fas fa-tag"></i></a></li>
                <li><a class="btn btn-sm btn-warning" href="http://demo.androidbubble.com/contact/" target="_blank"><?php _e('Contact Developer', 'wp-shopify'); ?> &nbsp;<i class="fas fa-headset"></i></a></li>
                <li><a class="btn btn-sm btn-secondary" href="<?php echo $wpsy_premium_copy; ?>/?help" target="_blank"><?php _e('Need Urgent Help?', 'wp-shopify'); ?> &nbsp;<i class="fas fa-phone"></i></i></a></li>
                <li style="display:none"><iframe width="560" height="315" src="https://www.youtube.com/embed/VyaF_20bg2U" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe></li>
            </ul>                
        </div>
    
    </div>  

</div>